require "import"
import "android.content.Intent"
import "android.net.Uri"
import "android.widget.*"
import "android.view.View"
import "android.content.Context"
import "android.os.Vibrator"
import "android.view.KeyEvent"

local context = activity or service
local dlg

local function openUrl(url)
    local intent = Intent(Intent.ACTION_VIEW)
    intent.setData(Uri.parse(url))
    intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
    context.startActivity(intent)
end

local function vibrateDevice(duration)
    local vibrator = context.getSystemService(Context.VIBRATOR_SERVICE)
    if vibrator.hasVibrator() then
        vibrator.vibrate(duration)
    end
end

local layout = {
    LinearLayout,
    orientation = LinearLayout.VERTICAL,
    padding = "16dp",
    {
        TextView,
        text = "Este plugin le permitirá chatear con Copilot mediante WhatsApp y Telegram.",
        textSize = "14sp",
        gravity = "center",
        layout_width = "match_parent",
        layout_height = "wrap_content",
        padding = "8dp",
    },
    {
        Button,
        text = "Abrir Copilot en Telegram",
        onClick = function(v)
            vibrateDevice(200)
            openUrl("https://t.me/CopilotOfficialBot")
            dlg.dismiss()
        end,
        layout_width = "match_parent",
        layout_height = "wrap_content",
    },
    {
        Button,
        text = "Abrir Copilot en WhatsApp",
        onClick = function(v)
            vibrateDevice(200)
            openUrl("https://wa.me/18772241042")
            dlg.dismiss()
        end,
        layout_width = "match_parent",
        layout_height = "wrap_content",
    },
    {
        Button,
        text = "Cerrar",
        onClick = function(v)
            vibrateDevice(200)
            dlg.dismiss()
        end,
        layout_width = "wrap_content",
        layout_height = "wrap_content",
        layout_gravity = "center_horizontal",
    },
}

dlg = LuaDialog(context)
dlg.setTitle("Chatea con Copilot por WhatsApp y Telegram")
dlg.setView(loadlayout(layout))
dlg.show()

function onKeyDown(code, event)
    if code == KeyEvent.KEYCODE_BACK then
        vibrateDevice(200)
        dlg.dismiss()
        return true
    end
end